<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>InterfaceSync xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/core/sync/InterfaceSync.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2015 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.core.sync;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.OperationUtils;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.DerivedElement;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Generalization;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Parameter;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Reception;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Signal;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLFactory;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> * Synchronize the use of a common superclass for signal reception with the</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> * question whether an interface has at least one owned reception.</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/sync/InterfaceSync.html">InterfaceSync</a> {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  	
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SIG_PREFIX = <span class="jxr_string">"SIG_"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment">	 * Name of an interface for generic reception support within the Qompass</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment">	 * sysinterfaces modeling library</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String SIGNAL_RECEPTION_QN = <span class="jxr_string">"sysinterfaces::SignalReception"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> useGenericSigInterface = false;
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> syncSignalReceptionSupport(Interface intf) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  		<strong class="jxr_keyword">if</strong> (useGenericSigInterface) {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  			syncGenericSignalReceptionSupport(intf);
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  			syncSpecificSignalReceptionSupport(intf);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		}
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> syncSpecificSignalReceptionSupport(Interface intf) {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		<strong class="jxr_keyword">for</strong> (Reception reception : intf.getOwnedReceptions()) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  			Signal signal = reception.getSignal();
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			<strong class="jxr_keyword">if</strong> (signal != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  				String opName = SIG_PREFIX + signal.getName();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  				Operation existingOperation = intf.getOwnedOperation(opName, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  				Operation newOperation = UMLFactory.eINSTANCE.createOperation();
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  				newOperation.setName(opName);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  				<strong class="jxr_keyword">for</strong> (Property attribute : signal.getAttributes()) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  					Parameter parameter = newOperation.createOwnedParameter(attribute.getName(), attribute.getType());
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  					parameter.setLower(attribute.getLower());
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  					parameter.setUpper(attribute.getUpper());
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  				}
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				<strong class="jxr_keyword">if</strong> (existingOperation == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  					intf.getOwnedOperations().add(newOperation);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  				} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (!OperationUtils.isSameOperation(existingOperation, newOperation)) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  					OperationUtils.syncOperation(newOperation, existingOperation);
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  				}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  				DerivedElement de = StereotypeUtil.applyApp(newOperation, DerivedElement.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				<strong class="jxr_keyword">if</strong> (de != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  					de.setSource(reception);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		<em class="jxr_comment">// now remove derived operations that are no longer needed.</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		EList&lt;Operation&gt; ownedOperations = <strong class="jxr_keyword">new</strong> BasicEList&lt;Operation&gt;();
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		ownedOperations.addAll(intf.getOwnedOperations());
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		<strong class="jxr_keyword">for</strong> (Operation operation : ownedOperations) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			DerivedElement de = UMLUtil.getStereotypeApplication(operation, DerivedElement.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  			<strong class="jxr_keyword">if</strong> (de != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  				<strong class="jxr_keyword">if</strong> (de.getSource() instanceof Reception) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  					Reception reception = (Reception) de.getSource();
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  					Signal signal = reception.getSignal();
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  					<strong class="jxr_keyword">if</strong> ((signal == <strong class="jxr_keyword">null</strong>) || !(SIG_PREFIX + signal.getName()).equals(operation.getName())) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  						<em class="jxr_comment">// reception exists, but has no signal or another signal</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  						operation.destroy();
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  					}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  				} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  					<em class="jxr_comment">// reception does not exist any more</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  					operation.destroy();
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  				}
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 			}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		}
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 	}
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> syncGenericSignalReceptionSupport(Interface intf) {
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		NamedElement genericReceptionNE = ElementUtils.getQualifiedElementFromRS(intf, SIGNAL_RECEPTION_QN);
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">if</strong> (genericReceptionNE instanceof Interface) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			Interface genericReceptionIntf = (Interface) genericReceptionNE;
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			<strong class="jxr_keyword">if</strong> (intf.getOwnedReceptions().size() &gt; 0) {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 				<strong class="jxr_keyword">if</strong> (!hasReceptionSupport(intf, genericReceptionIntf)) {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 					addReceptionSupport(intf, genericReceptionIntf);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 				}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (hasReceptionSupport(intf, genericReceptionIntf)) {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 				removeReceptionSupport(intf, genericReceptionIntf);
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 			}
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 	}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">boolean</strong> hasReceptionSupport(Interface intf, Interface genericReceptionIntf) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		<em class="jxr_comment">// TODO: does it find an indirect reception?</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		<strong class="jxr_keyword">for</strong> (Classifier general : intf.getGenerals()) {
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			<strong class="jxr_keyword">if</strong> (general == genericReceptionIntf) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		}
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 	}
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> addReceptionSupport(Interface intf, Interface genericReceptionIntf) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		intf.createGeneralization(genericReceptionIntf);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 	}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> removeReceptionSupport(Interface intf, Interface genericReceptionIntf) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		<strong class="jxr_keyword">for</strong> (Generalization generalization : intf.getGeneralizations()) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			<strong class="jxr_keyword">if</strong> (generalization.getGeneral() == genericReceptionIntf) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 				generalization.destroy();
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		}
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
